sub open_socket
{
    local( $handle ) = $_[ 0 ];
    local( $ip, $pop3, $previous );

    $ip = ( gethostbyname( $host ) )[ 4 ];

    # 2 -> AF_INET
    $pop3 = pack( 'S n a4 x8', 2, 110, $ip );

    # å
    #   2 -> AF_INET
    #   1 -> SOCK_STREAM
    socket( $handle, 2, 1, getprotobyname( 'tcp' ) ) || return( 0 );

    # ³
    connect( $handle, $pop3 ) || return ( 0 );

    # Хåե󥰥
    $previous = select( $handle );
    $| = 1;
    select( $previous );

    # ³ơ
    $_ = <$handle>;
    # ｪλ
    return( 1 ) if( /^\+/ );

    # 顼ʤ饽åȤϥƤ
    &close_socket( $handle );
    return( 0 );
}

sub close_socket
{
    local( $handle ) = $_[ 0 ];

    # quit
    print $handle "quit\n";
    # ꥿å
    $_ = <$handle>;

    close( $handle );
}

sub authenticate
{
    local( $handle, $username, $password ) = @_;
    local( $length );

    # user 桼̾
    print $handle "user $username\n";
    # ޥɥơ
    $_ = <$handle>;
    # 顼ʤ꥿
    return( 0 ) if( /^-/ );

    # pass ѥ
    print $handle "pass $password\n";
    # ޥɥơ
    $_ = <$handle>;
    # ｪλ
    return( 1 ) if( /^\+/ );

    # 顼ʤ饽åȤϥƤ
    &close_socket( $handle );
    return( 0 );
}

sub list_mails
{
    local( $handle ) = $_[ 0 ];

    # list
    print $handle "list\n";
    # ޥɥơ
    $_ = <$handle>;
    # 顼ʤ饽åȤϥƤ
    if( /^-/ )
    {
        &close_socket( $handle );
        return( 0 );
    }

    # ꥹȼ
    while( <$handle> )
    {
        last if( /^\./ );
        push( contents, $_ );
    }

    # ｪλ
    return( 1 );
}

sub retrieve
{
    local( $handle, $number ) = @_;
    local( $boundary, $encoding, @tmp );

    # retr ֹ
    print $handle "retr $number\n";
    # ޥɥơ
    $_ = <$handle>;
    # 顼ʤ饽åȤϥƤ
    if( /^-/ )
    {
        &close_socket( $handle );
        return( 0 );
    }

    # ᡼
    while( <$handle> )
    {
        last if( /^\.\r\n$/ );

        # EUCѴ
        &jcode'convert( *_, 'euc' );
        # Ƭ...֤
        s/^\.\././;

        push( contents, $_ );
    }

    # ｪλ
    return( 1 );
}

1;
